#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>

#define THREADS  3
#define INC_ZYKLEN 4
#define WAIT_COUNT 4
#define COND_COUNT 5

int     count = 0;
int     thread_ids[3] = {0,1,2};
pthread_mutex_t count_lock; 
pthread_mutex_t count_lock1; 
pthread_cond_t count_hit=PTHREAD_COND_INITIALIZER; 

void prwatch(char *text,  int count)
{
   printf("Thread %02d: inc_watch(): count=%d, %s\n", 
    (unsigned int)pthread_self()%100,count,text);
}

void prcount(char *text, int count)
{
   printf("Thread %02d: inc_count(): count=%d, %s\n", 
    (unsigned int) pthread_self()%100,count,text);
}

void *inc_count(void *idp)
{
  int i=0, sl=0;

  prcount("start",count);
  for (i=0; i<INC_ZYKLEN; i++) {
    prcount("vor mutex_lock",  count);
    pthread_mutex_lock(&count_lock);
    prcount("nach mutex_lock",  count);
    count++;
    if (count == COND_COUNT) {
      prcount("        vor cond_signal",  count);
      pthread_cond_signal(&count_hit);
      prcount("        nach cond_signal",  count);
      /*count++;*/
    }
    prcount("mutex_unlock",  count);
    pthread_mutex_unlock(&count_lock);
    sl= random() % 2;
    if ( sl ) sleep(1);
  }
  prcount("fertig", count);
  return(NULL);
}

void *watch_count(void *idp)
{

  prwatch("start", count);
  prwatch("vor mutex_lock", count);
  pthread_mutex_lock(&count_lock);
  prwatch("nach mutex_lock", count);
  while (count < WAIT_COUNT) {
    prwatch("        vor cond_wait",  count);
    pthread_cond_wait(&count_hit, &count_lock);
    prwatch("        nach cond_wait",  count);
    count++;
  }
  pthread_mutex_unlock(&count_lock);
  prwatch("fertig", count);
  return(NULL);
}

int main()
{
  int       i;
  pthread_t threads[3];

  pthread_mutex_init(&count_lock,NULL);
  pthread_mutex_init(&count_lock1,NULL);
  pthread_create(&threads[0], NULL, inc_count, (void *)&thread_ids[0]);
  pthread_create(&threads[1], NULL, inc_count, (void *)&thread_ids[1]);
  pthread_create(&threads[2], NULL, watch_count, (void *)&thread_ids[2]);

  for (i = 0; i < THREADS; i++) {
    pthread_join(threads[i], NULL);
  }
  exit(0);
}


