#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <stdio.h>

void do_one_thing(int *);
void do_another_thing(int *);
void do_wrap_up(int, int);

int r1 = 0, r2 = 0, r3 = 0, g = 0;

pthread_mutex_t r3_mutex;
pthread_mutex_t g_mutex;


int main(int argc, char **argv)
{ pthread_t       thread1, thread2;

  pthread_mutex_init(&r3_mutex, NULL);
  pthread_mutex_init(&g_mutex, NULL);
  if (argc < 2)  {
	printf("usage %s number\n", argv[0]); 
        exit(1);  
  }
  r3 = atoi(argv[1]);
  pthread_create(&thread1, NULL, (void *) do_one_thing, (void *) &r1); 
  pthread_create(&thread2, NULL, (void *) do_another_thing, (void *) &r2); 
  pthread_join(thread1, NULL);
  pthread_join(thread2, NULL);
  do_wrap_up(r1, r2);
  exit(0);
}

void do_one_thing(int *pnum_times)
{ int  i,s1,s2;
  static int l=0;
 
  for (i = 0;  i < 4; i++) {
    printf("do_one_thing 1:             r3=%d,g=%d,l=%d\n",r3,g,l);
    pthread_mutex_lock(&r3_mutex);
    if (r3 > 3) r3--; 
    pthread_mutex_unlock(&r3_mutex); 
    pthread_mutex_lock(&g_mutex);
    s1=g+1; s2=l+1;
    sleep(2);
    g=s1; l=s2; 
    printf("do_one_thing 2:             r3=%d,g=%d,l=%d\n",r3,g,l);
    pthread_mutex_unlock(&g_mutex); 
    (*pnum_times)++;
  }
}

void do_another_thing(int *pnum_times)
{ int i,s1,s2;
  static int l=0;
 
  for (i = 0;  i < 4; i++) {
    printf("do_another_thing 1:         r3=%d,g=%d,l=%d\n",r3,g,l);
    pthread_mutex_lock(&r3_mutex);
    if (r3 > 3)  r3--; 
    pthread_mutex_unlock(&r3_mutex); 
    pthread_mutex_lock(&g_mutex);
    s1=g+1; s2=l+1;
    sleep(1);
    g=s1; l=s2; 
    printf("do_another_thing 2:         r3=%d,g=%d,l=%d\n",r3,g,l);
    pthread_mutex_unlock(&g_mutex); 
    (*pnum_times)++;
  }
}

void do_wrap_up(int one_times, int another_times)
{ int total;

  total = one_times + another_times;
  printf("All done, one thing %d, another %d for a total of %d\n",
	one_times, another_times, total);
}
