#include   <stdio.h>
#include   <stdlib.h>
#include   <unistd.h>
#define _DEFAULT_SOURCE 1
#include   <signal.h>

#define SV_RESETHAND	(1<<2)

typedef struct sigvec {
	         void (*sv_handler)(int); /* Signal disposition */
	         int    sv_mask;          /* Signals to be blocked in handler */
	         int    sv_flags;         /* Flags */
} sigvec_t;

void sig_usr(int signo)      /* argument is signal number */
{
   int z1;
   static int z2=0;

   if ((signo != SIGUSR1) && (signo != SIGUSR2)) {
      fprintf(stderr,"received signal %d\n", signo);
      exit(3);
   }
   z2++; z1=z2;
   printf("Start  Signal %d: z1=%d, z2=%d\n",signo,z1,z2);
   sleep(5); z2++;
   printf("Fertig Signal %d: z1=%d, z2=%d\n",signo,z1,z2);
   return;
}

int main()
{
   struct sigvec  newsg, oldsg;

   newsg.sv_handler =  sig_usr;
   newsg.sv_mask = 0 ; 
   newsg.sv_flags= 0; /* default, Handler beibehalten */
   printf("PID=%d, SIGUSR1: %d, SIGUSR2: %d\n",(int) getpid(),SIGUSR1,SIGUSR2);
   if (sigvec(SIGUSR2, &newsg, &oldsg) < 0) {
      fprintf(stderr,"can't catch SIGUSR2");
      exit(1);
   }
   newsg.sv_flags= SV_RESETHAND; /* Handler nach 1. Aufruf abschalten*/
   if (sigvec(SIGUSR1, &newsg, &oldsg) <0) {
      fprintf(stderr,"can't catch SIGUSR1");
      exit(2);
   }
   for ( ; ; ) 
      pause();
   exit (0);
}
