#include   <setjmp.h>
#include   <signal.h>
#include   <unistd.h>
#include   <stdio.h>
#include   <stdlib.h>

int debug=0;

static jmp_buf   env_alrm;

void sig_alrm(int signo)
{  
    printf("SIGALRM aufgetreten\n");
    longjmp(env_alrm, 1); 
}

unsigned int sleep(unsigned int nsecs)
{
   if (signal(SIGALRM, sig_alrm) == SIG_ERR) return(nsecs);
   printf("sleep aufgerufen\n");
   printf("alarm setzen auf %u Sekunden\n",nsecs);
   alarm(nsecs);      /* starten des Timers */
   if (setjmp(env_alrm)==0)  /* setjmp liefert 0, longjmp liefert 1 */
      while(1) {  /* unendliche Schleife */
          printf("pause\n");
          pause();
          if (debug) {
              nsecs=alarm(0);
              printf("alarm setzen auf %u Sekunden\n",nsecs);
              alarm(nsecs); 
          }
      }
   return(alarm(0)); 
}

void sig_int(int signo)
{
  if (signal(SIGINT, sig_int) == SIG_ERR) {
    printf("signal(SIGINT) error"); exit(1);
  }
  printf("\nSIGINT aufgetreten\n");
  return;
}

int main()
{
  unsigned int  unslept;

  if (signal(SIGINT, sig_int) == SIG_ERR) {
    printf("signal(SIGINT) error"); exit(1);
  }
  printf("Warten auf CNTRL/C\n");
  unslept = sleep(5);
  printf("Rueckkehrwert von sleep: %u\n", unslept);
  exit(0);
}
